$crystal = 12000000
$baud = 1200
$regfile = "attiny2313.dat"

Config Pinb.4 = Input                                       'hdd
Config Pinb.6 = Output                                      'power
Config Pinb.7 = Output                                      'polaczono
Config Pinb.5 = Input                                       'power komp
Config Pinb.2 = Output                                      'przycisk power
Config Pinb.3 = Output                                      'przycisk reset

Config Timer1 = Timer , Prescale = 256

Hdd Alias Pinb.4                                            ' stan dysku czyta lub nie
Powerk Alias Portb.6                                        ' dioda power od orzadzenia
Polaczono Alias Portb.7                                     ' komunikacja tak nie
Diodapowerk Alias Pinb.5                                    ' stan kompa czy wl/wyl
Ppower Alias Portb.2                                        ' przycisk power
Preset Alias Portb.3                                        ' przycisk reset
Portb.4 = 1                                                 'podciaganie
Powerk = 0                                                  'urz wlaczone
Polaczono = 1                                               'brak komunikacji
Portb.5 = 1                                                 'podciaganie



'Dim Blokuj As Byte                                          'tylko raz nacisnij power przy wl kompa
Dim Odbierz As Byte
Dim Kom As Byte                                             ' Komunikacja
Dim Licznik As Byte
Dim Dana As Byte
Dim Bufor As Byte
'Dim Bufor2 As Byte
Dim Lmigaj As Byte
Kom = 0
'Blokuj = 0
Timer1 = 60849                                              '60849
Enable Timer1
Enable Interrupts
On Timer1 Przerwanie
Do
Gosub Sprawdz



Komunikacja:
If Kom = 1 Then
  ' Disable Timer1
    Dana = 1                                                ' komp wyl
    If Diodapowerk = 1 Then Dana = 2                        ' komp wl
    If Hdd = 1 Then
      If Dana = 2 Then Dana = 4                             ' hdd dziala wiec komp wl
    End If
    Print Chr(dana);
    Incr Lmigaj
    If Lmigaj > 100 Then
      Lmigaj = 0
      Toggle Polaczono
    End If
       Licznik = 3
Pczekaj1:
  '    Waitms 2                                              '0
   Odbierz = Inkey()
   If Odbierz > 0 Then
      If Odbierz > 31 Then Kom = 0                          ' bledne dane
      ' 1 wl komp
      ' 2 wyl komp
      ' 4 reset
      ' 8 wyl na chama
      ' 16 nie rob nic
      Bufor = Odbierz And 1
    '  Bufor2 = Dana And 2
      If Bufor = 1 Then                                     ' wl komp
         If Dana = 1 Then                                   ' gdy wyl
            Ppower = 1
            Waitms 100
            Ppower = 0
            'Incr Blokuj
         End If
     End If

      Bufor = Odbierz And 2
    '  Bufor2 = Dana And 2
      If Bufor = 2 Then                                     'wyl komp
         If Dana > 1 Then                                   'gdy wl
            Ppower = 1
            Waitms 100
            Ppower = 0
            'blokuj = 0
         End If
      End If

      Bufor = Odbierz And 4                                 'reset
      If Bufor = 4 And Diodapowerk = 1 Then                 'tylko gdy komp jest wl
            Preset = 1
            Waitms 100
            Preset = 0
      End If

      Bufor = Odbierz And 8                                 'wyl na chama
      If Bufor = 8 And Diodapowerk = 1 Then
Wylnachama:
         Ppower = 1
   '      Wait 1
         If Diodapowerk = 1 Then Goto Wylnachama
         Ppower = 0
         'blokuj = 0
      End If

   Else
     'nic nie odebrano po wyslaniu liczby

      If Licznik = 0 Then
         Kom = 0
         Powerk = 1
         Waitms 500
         Powerk = 0
       Else
         Goto Pczekaj1
      End If
   End If
End If
If Kom = 1 Then Goto Komunikacja

Koniec:                                                     'utrata komunikacji
Polaczono = 1
'Disable Timer1
'Disable Interrupts
Loop

Przerwanie:
If Licznik > 0 Then Decr Licznik
   Timer1 = 60849
Return

Sprawdz:                                                    'spr komunikacji
   Print Chr(77);                                           'M pierwsza liczba
   Licznik = 10
Czekaj1:
   If Licznik = 0 Then
Czekaj11:
      Powerk = 1
      Waitms 200
      Powerk = 0
      Goto Sprawdz
   End If
   Odbierz = Inkey()
   If Odbierz = 0 Then
      Waitms 1                                              '00                                            'nic nie odebrano po wyslaniu 1 liczby
   '   Decr Licznik
      Goto Czekaj1
   End If
      If Odbierz <> 65 Then Goto Czekaj11
         Print Chr(157);                                    'drga liczba
         Licznik = 10
Czekaj2:
         If Licznik = 0 Then Goto Czekaj11
         Odbierz = Inkey()
         If Odbierz > 0 Then
            If Odbierz <> 66 Then Goto Czekaj11
               Polaczono = 0                                'zielona dioda
               Kom = 1
               Lmigaj = 0
         Else
           Waitms 1                                         '00                                       'nic nie odebrano po wyslaniu 2 liczby
      '     Decr Licznik
           Goto Czekaj2
         End If

Return